"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sendableToString = sendableToString;
exports.formatSendable = formatSendable;
const zhin_1 = require("zhin");
function sendableToString(message) {
    let result = '';
    if (!Array.isArray(message))
        message = [message];
    for (const item of message) {
        if (typeof item === 'string') {
            result += item;
            continue;
        }
        const { type, ...data } = item;
        if (type === 'text') {
            result += item['text'];
            continue;
        }
        const attrs = Object.entries(data).map(([key, value]) => {
            return `${key}='${JSON.stringify(value)}'`;
        });
        result += `<${type} ${attrs.join(' ')}>`;
    }
    return result;
}
function formatSendable(message) {
    const result = [];
    if (!Array.isArray(message))
        message = [message];
    for (const item of message) {
        if (typeof item !== 'string') {
            result.push(item);
        }
        else {
            result.push(...(0, zhin_1.parseFromTemplate)(item).map(item => {
                const { type, data } = item;
                return {
                    type,
                    ...data,
                };
            }));
        }
    }
    return result;
}
